
- name: Postgresql Password 
  include_tasks: "postgresql_password.yml" 

- name: Postgresql Pod 
  include_tasks: "postgresql_pod.yml" 

- name: Create Backup with pg_dump
  shell: |
    kubectl exec -n {{ database_namespace }} {{ postgresql_pod_name }} -- \
      bash -c 'PGPASSWORD={{ postgresql_password }} pg_dump -Fc {{ database }} --username=postgres -f /tmp/{{ database }}.dump'

- name: Copy Backup to local
  shell: |
    kubectl cp -n {{ database_namespace }} {{ postgresql_pod_name }}:tmp/{{ database }}.dump {{ install_dir }}/{{ database }}/{{ database }}.dump

- name: Check Restore file exists
  stat:
    path: "{{ install_dir }}/{{ database }}/{{ database }}.dump"
  register: dump
  failed_when: dump.stat.exists == false

- name: Get Minio Secret
  k8s_secret_info:
    namespace: "{{ config.backup_vault.namespace }}"
    name: minio-secret
  register: minio_secret

- name: "Create backup bucket"
  s3_bucket:
    name: "{{ database_namespace }}"
    state: present
    s3_url: "https://{{ config.backup_vault.fqdn }}"
    aws_access_key: "{{ minio_secret['accesskey'] }}"
    aws_secret_key: "{{ minio_secret['secretkey'] }}"

- name: Save file in S3
  aws_s3:
    aws_access_key: "{{ minio_secret['accesskey'] }}"
    aws_secret_key: "{{ minio_secret['secretkey'] }}"
    bucket: "{{ database_namespace }}"
    mode: put
    encrypt: false
    object: "{{ database }}-{{ lookup('pipe','date +%Y%m%d%H%M%S') }}.dump"
    src: "{{ install_dir }}/{{ database }}/{{ database }}.dump"
    s3_url: "https://{{ config.backup_vault.fqdn }}"
